/*
	Loading screen by Mellow Man
*/

// The screens to load:
var screensToLoad = {
	MENU: {sector: 110, blipps: 149, title1: "    THE", title2: "    MAIN MENU"
	 , url: null
	 , text:"\
	YOU'RE LOADING THE CUDDLY MAIN MENU, CODED BY THE CAREBEARS. MUZEXX BY MAD, THE MAX. MOST GRAPHIXX BY TCB, BUT SOME BY TANIS AND ES OF TEX.     \
	"
	},

	BIG_SPRITE: {sector: 49, blipps: 162, title1: "  THE BIG", title2: "   SPRITE DEMO"
	 , url: "cuddly_big_sprite.html"
	 , text:"YOU'RE LOADING THE BIG SPRITE, SCHMUCK.  IT WAS CODED BY THE CAREBEARS, THE MUZEXX WAS DONE BY MAXIMUM MAD, GRAPHIX BY TCB, WITH SOME BY TANIS.    "
	},

	COLORSHOCK_II: {sector: 45, blipps: 89, title1: "    THE", title2: "   COLORSHOCK2"
	 , url: "cuddly_colorshock2.html"
	 , text:"COLORSHOCK II IS BEING LOADED..   CODING BY TCB. MUZEXX BY  MAAAH MAAAH OF TEX...    "
	},

	NO_NAME_1: {sector: 81, blipps: 117, title1: "THE EHHH!!!!", title2: "      DEMO"
	 , url: "cuddly_ehh_demo.html"
	 , text:"WAIT WHILE LOADING...  EHHH...  WELL... WE DON'T KNOW WHAT TO NAME IT. SEND SUGGESTIONS TO US...   "
	},

	MEGA_SCROLLER: {sector: 131, blipps: 172, title1: "    THE", title2: "  MEGA SCROLLER"
	 , url: "cuddly_megascroller.html"
	 , text:"DUM DURUDUMDUM DE DUUMMMM...  THE CAREBEARS PRESENT THE MEGASCROLLER...   YES, OF COURSE IT WAS CODED BY THE CAREBEARS.  THE SMALL BLUE SQUARE WERE DONE BY TANIS.   "
	},

	SPREADPOINT: {sector: 74, blipps: 123, title1: "SPREADPOINT", title2: "      DEMO"
	 , url: "cuddly_spreadpoint.html"
	 , text:"PREPARE FOR THE ULTIMATE BRAIN BLASTER. THE CAREBEARS PRESENTS THE SPREADPOINT DEMO...      "
	},

	DIGI_DEMO: {sector: 118, blipps: 173, title1: "    THE", title2: "    DIGI DEMO"
	 , url: "cuddly_digisound.html"
	 , text:"WAIT WHILE LOADING THE DIGIDEMO, CODED BY THE CAREBEARS. THE GRAPHIXX WAS DONE BY TCB AND TEX. THE TUNE WAS COMPOSED BY KARSVALL...      "
	},

	LED_SCROLLER: {sector: 141, blipps: 040, title1: "    THE", title2: "  LED  SCROLLER"
	 , url: "cuddly_led_scroller.html"
	 , text:"YOU WILL SOON SEE OUR (THE CAREBEARS'. MUSHROOMBRAIN) LED SCROLLER DEMO...      "
	},
    
	DOC: {sector: 53, blipps: 99, title1: "THE  3D DOC", title2: "      DEMO"
	 , url: "cuddly_3d_doc.html"
	 , text:"BELIEVE IT OR NOT, BUT HERE IS ANOTHER DOC DEMO. THIS IS THE FIRST ONE WITH 3D BALLS...   "
	},

	FULLSCREEN: {sector: 167, blipps: 221, title1: "THEFULLSCREEN", title2: "      DEMO"
	 , url: "cuddly_fullscreen.html" 
	 , text:"IT'S NOT QUITE AS FULL AS THE LEVEL 16 ONE, BUT IT'S MUCH MORE AMAZING. IT SHOULD BE IMPOSSIBLE TO MAKE, BUT OF COURSE WE MANAGE IT ANYWAY......        "
	},

	STARWARS_DEMO: {sector: 108, blipps: 219, title1: "    THE", title2: "  STARWARS DEMO"
	 , url: "cuddly_starwarsscroller.html"
	 , text:"THE STARWARSDEMO WAS CODED BY THE CAREBEARS THE FONT WAS DONE BY THE KNIGHTHAWKS (AMIGA), UGLY FONT BY TCB AND SPRITES BY TANIS...       "
	},

	KNUCKLE_BUSTER: {sector: 67, blipps: 117, title1: "    THE", title2: "  KNUCKLEBUSTER"
	 , url: "cuddly_knucklebuster.html"
	 , text:"A GUEST APPEARANCE!!!   THE EXCEPTIONS PRESENT THE KNUCKLEBUSTER. READ THE SCROLLER FOR MORE INFORMATION...     "
	},

	DNA_DEMO: {sector: 130, blipps: 200, title1: "    THE", title2: "    DNA  DEMO"
	 , url: "cuddly_dna_demo.html"
	 , text:"PUMP UP THE VOLUME AND GO GET SOME COKE, COZ YOU'RE ABOUT TO SEE THE DNA DEMO.  "
	},

	NO_NAME_2: {sector: 40, blipps: 109, title1: "THE MEGABALL", title2: "      DEMO"
	 , url: "cuddly_megaball.html"
	 , text:"HERE COMES THE MEGABALL DEMO.  WAIT, AND DISCOVER THAT IT'S ANOTHER DOC LOOKALIKE DEMO...      "
	},

	CREDITS: {sector: 43, blipps: 76, title1: " THE CODEF", title2: "  CREDITS SCREEN"
	 , url: "cuddly_credits.html"
	 , text:"THIS IS THE HIDDEN CREDITS SCREEN, NOT ORIGINAL, BUT FOR THE CODEF TEAM WHO REMADE THIS GREAT DEMO...      "
	}

}

var song=basepath + 'loader.wav';
var faded=0;

var loadtune = null;

// string name of screen to load from 'screensToLoad' above
var screenToLoad;

var fontgrey = new image(basepath + 'fontL.png');
var fontbrown = new image(basepath + 'fontN.png');
var maini=new image(basepath + 'loader.png');
var decrunch=new image(basepath + 'decrunch.png');

var scrollcanvas;

var sector = 0;
var blipps = 0;

var scrolltext;

var text = "";
var title1;
var title2;

function loaderInit(){
	scrollcanvas=new canvas(640,16);

	fontbrown.initTile(16,16,32);
	fontgrey.initTile(16,16,32);
}

// This function is called by the menu to show the loader (everything is controlled via the menu)
// demo = a string containing the names above in screensToLoad.
function loader(demo) {
	screenToLoad = demo; // need to remember value in demo to actually load the screen url

	if (loadtune) 
		loadtune.stop();

	loadtune=new Howl({
	  	src: [song],
	  	autoplay: false,
	  	loop: true,
		rate: 1,
	  	onload: function() {
			loadtune.play();
	 	}
	});

	// Setup loader for the selected screen
	var screen = screensToLoad[demo];
	sector = screen.sector;
	blipps = screen.blipps;

	title1 = screen.title1;
	title2 = screen.title2;

	text = screen.text;

	scrolltext = new scrolltext_horizontal();
	scrolltext.scrtxt=text;
	scrolltext.init(scrollcanvas,fontgrey,6);

	faded=0;

	go();
}

function insertSpaces(n) {
	var c = 3 - String(n).length;
	var r = "";
	for(var i=0; i<c; i++)
		r += " ";

	return r;
}

function go(){
	mycanvas.fill('#000000');

	if (faded==0){
		maini.draw(mycanvas,64,64);

		fontbrown.print(mycanvas,title1,496,124);
		fontbrown.print(mycanvas,title2,512-64,138+2);
		fontbrown.print(mycanvas, insertSpaces(sector) + sector,546+16, 212+4);

		if (sector==0){
			fontbrown.print(mycanvas,"DECRUNCH MICRO",480+2,236+8);
			fontbrown.print(mycanvas," BLIPPS TO GO",480+2,260+8);
			if (blipps>=0){
				fontbrown.print(mycanvas, insertSpaces(blipps) + blipps,546+16,276+8);
			} else {
				fontbrown.print(mycanvas,"  0",546+16,276+8);
			}
		}

		if (sector>=1) sector--;
		if (sector==0) blipps--;
		
		scrollcanvas.clear();
		scrolltext.draw(0);
		scrollcanvas.draw(mycanvas,64,450);

		if ((sector==0)&&(blipps==40)) loadtune.fade(1,0,1500); // Music fades out earlier now, please change if not same as original etc
		if ((sector==0)&&(blipps<=-25))  faded=1;
	} else {
		loadScreen();
		return;
	}

	crtEmulator.updateFrame();
	requestAnimFrame( go );
}

function loadScreen() {
	// delay to let the music stop + add black pause between screens - please adjust if not same as original
	mycanvas.fill('#000000');
	crtEmulator.updateFrame();

	if (screenToLoad == "MENU") {
		// Handle loading menu
		setTimeout(function() {
			cuddlyMenuScreen.go();
		}, 250);
	} else {
		// Handle loading a screen - delay is to let the music fade out
		setTimeout(function() {
			window.location.href = screensToLoad[screenToLoad].url;
		}, 250);
	}

}
