/*
	CARL TO ADD COPYRIGHT STUFF HERE
*/

// The screens to load:
var screensToLoad = {
	MENU: {sector: 110, blipps: 149, title1: "THE", title2: "MAIN MENU"
	 , url: null
	 , text:"\
	YOU'RE LOADING THE CUDDLY MAIN MENU, CODED BY THE CAREBEARS. MUZEXX BY MAD, THE MAX. MOST GRAPHIXX BY TCB, BUT SOME BY TANIS AND ES OF TEX.     \
	"
	},

	BIG_SPRITE: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	COLORSHOCK_II: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	NO_NAME_1: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	MEGA_SCROLLER: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	SPREADPOINT: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	DIGI_DEMO: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	LED_SCROLLER: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	DOC: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	FULLSCREEN: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	STARWARS_DEMO: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	KNUCKLE_BUSTER: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	DNA_DEMO: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	},

	NO_NAME_2: {sector: 110, blipps: 149, title1: "TODO", title2: "TODO"
	 , url: "4k/4k_intro.html"
	 , text:"TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO        "
	}

}

var song=basepath + 'loadingsample.mp3';
var faded=0;

var loadtune=new Howl({
  	src: [song],
  	autoplay: false,
  	loop: true,
	rate: 1,
  	onload: function() {
		console.log("LOADING SAMPLES...");
 	}
});

// string name of screen to load from 'screensToLoad' above.
var screenToLoad;

var fontgrey = new image(basepath + 'fontL.png');
var fontbrown = new image(basepath + 'fontN.png');
var maini=new image(basepath + 'loader.png');
var decrunch=new image(basepath + 'decrunch.png'); // X 482 Y 236

var mycanvas;
var scrollcanvas;

var sector = 0;
var blipps = 0;

var scrolltext;

var text = "";
var title1;
var title2;

// Called by menu bootstrapping to init Carl's code:
function loaderInit(){
	mycanvas=new canvas(768,540,"loader");

	scrollcanvas=new canvas(640,16);

	fontbrown.initTile(16,16,32);
	fontgrey.initTile(16,16,32);

	// Dave: Scrolltext object moved below as text needs to change for each screen.
}

// This function is called by the menu to show the loader (everything is controlled via the menu)
// demo = a string containing the names above in screensToLoad.
function loader(demo) {
	screenToLoad = demo; // need to remember value in demo to actually load the screen url

	// Show loader screen
	document.getElementById("loader").style.display = "block";
	loadtune.play();

	// Setup loader for the selected screen
	var screen = screensToLoad[demo];
	sector = screen.sector;
	blipps = screen.blipps;

	title1 = screen.title1;
	title2 = screen.title2;

	text = screen.text;

	scrolltext = new scrolltext_horizontal();
	scrolltext.scrtxt=text;
	scrolltext.init(scrollcanvas,fontgrey,6);

	faded=0;

	go();
}

function go(){
	mycanvas.fill('#000000');

	if (faded==0){
		maini.draw(mycanvas,64,64);

		fontbrown.print(mycanvas,title1,560,124);
		fontbrown.print(mycanvas,title2,512,138);
		fontbrown.print(mycanvas," "+sector,546, 212);

		if (sector==0){
			fontbrown.print(mycanvas,"DECRUNCH MICRO",480,236);
			fontbrown.print(mycanvas," BLIPPS TO GO",480,260);
			if (blipps>=0){
				fontbrown.print(mycanvas," "+blipps,546,276);
				} else {
				fontbrown.print(mycanvas," 0",546,276);
				}
			}

		if (sector>=1) sector--;
		if (sector==0) blipps--;
		
		scrollcanvas.clear();
		scrolltext.draw(0);
		scrollcanvas.draw(mycanvas,64,450);

		if ((sector==0)&&(blipps==40)) loadtune.fade(1,0,1500); // Music fades out earlier now, please change if not same as original etc
		if ((sector==0)&&(blipps<=-25))  faded=1;
	} else {
		loadScreen();
		return;
	}

	requestAnimFrame( go );
}

function loadScreen() {
	// delay to let the music stop + add black pause between screens - please adjust if not same as original.
	mycanvas.fill('#000000');

	if (screenToLoad == "MENU") {
		// Handle loading menu:
		setTimeout(function() {
			document.getElementById("loader").style.display = "none";
			cuddlyMenuScreen.go();
		}, 250);
	} else {
		// Handle loading a screen - delay is to let the music fade out:
		setTimeout(function() {
			window.location.href = screensToLoad[screenToLoad].url;
		}, 250);
	}

}


/*
Dave: This lot is no longer needed

function launch_reset(){
	window.event;
	window.open('cuddly_reset.html' , '_self');
}

function launch_menu(){
	window.event;
	window.open('cuddly_menu.html' , '_self');
}
*/

/*
document.onkeydown = KeyCheck;       

function KeyCheck(ev){
	if (!ev) var ev=window.event;
	var KeyID = ev.keyCode;

	switch(KeyID){
		case 32: 
			// stop music if required
			launch_menu();
			ev.preventDefault();
        		return false;
			break;
		case 82: 
			// stop music if required
			launch_reset();
			ev.preventDefault();
        		return false;
			break;
	}
}
*/